package com.allinpay.yst2.demo.tx;

import com.allinpay.yst2.demo.util.DemoSM4Utils;
import com.allinpay.yst2.demo.util.TxUtils;
import com.allinpay.yst2.demo.vo.BizParameter;
import com.allinpay.yst2.demo.vo.TxResponse;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 【消费申请】
 *
 * @author gejunqing
 * @version 1.0
 * @date 2024/1/11
 */
public class Tx2085Demo extends TxDemo
{
    public static void main(String[] args) throws Exception
    {
    	// 支付模式
        String bankCardNo=DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(),"6212261001029054530");
    	//微信正扫
        Map<String, Object> SCAN_WEIXIN = new HashMap<>(); 
        SCAN_WEIXIN.put("SCAN_WEIXIN","{\"limitPay\":\"no_credit\"}");
        SCAN_WEIXIN.put("SCAN_WEIXIN","{\"vspCusid\":\"552100053118ZCK\"}");
//        SCAN_WEIXIN.put("SCAN_WEIXIN","{\"extendParams\":\"渠道扩展参数\"}"); 
//        SCAN_WEIXIN.put("SCAN_WEIXIN","{\"idNo\":\"\"}"); 
//        SCAN_WEIXIN.put("SCAN_WEIXIN","{\"name\":\"\"}"); 
//        SCAN_WEIXIN.put("SCAN_WEIXIN","{\"cardThype\":\"\"}"); 

        //银联正扫
        Map<String, Object> SCAN_UNIONPAY = new HashMap<>();
        SCAN_UNIONPAY.put("SCAN_UNIONPAY","{\"limitPay\":\"no_credit\"}");

        //支付宝正扫
        Map<String, Object> SCAN_ALIPAY = new HashMap<>();
        SCAN_ALIPAY.put("SCAN_ALIPAY","{\"limitPay\":\"no_credit\"}");
        SCAN_ALIPAY.put("SCAN_ALIPAY","{\"vspCusid\":\"552100053118ZCV\"}");

        //收银宝POS
        Map<String, Object> ORDER_VSPPAY = new HashMap<>();
        ORDER_VSPPAY.put("ORDER_VSPPAY","{\"vspCusid\":\"6602900601500JK\"}");

        //付款码支付
        Map<String, Object> CODEPAY_VSP = new HashMap<>();
        CODEPAY_VSP.put("CODEPAY_VSP","{\"vspCusid\":\"\"}");
        CODEPAY_VSP.put("CODEPAY_VSP","{\"authcode\":\"280310687633511560\"}");

        //H5收银台
        Map<String, Object> H5_CASHIER_VSP = new HashMap<>();
        H5_CASHIER_VSP.put("H5_CASHIER_VSP","{\"vspCusid\":\"\"}");


      //订单过期时间
	    final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		final Calendar calendar = Calendar.getInstance();
		calendar.add(Calendar.MINUTE, 720);
		final Date date = calendar.getTime();
		final String orderValidTime = sdf.format(date);
    	
    	// 组装参数
        BizParameter bizParameter = new BizParameter();
        bizParameter.addParam("receiverSignNum", "711110001");
        bizParameter.addParam("reqTraceNum", "tjh"+TxUtils.genReqTraceNum());//商户订单号
        bizParameter.addParam("orderAmount", 2);//订单金额
        bizParameter.addParam("payAmount", 2);//支付金额
//        bizParameter.addParam("couponAmount",1 );//平台抽佣金额
        bizParameter.addParam("industryCode", 1234);//
        bizParameter.addParam("industryName", 1234);//
        bizParameter.addParam("verifyType", 0);//交易验证方式-0：无验证、1：短信验证码（默认-1：短信验证码）

        //支付模式
        bizParameter.addMapParam("payMode", SCAN_ALIPAY);//支付宝正扫
//        bizParameter.addMapParam("payMode", SCAN_UNIONPAY);//银联正扫
//        bizParameter.addMapParam("payMode", SCAN_ALIPAY);//支付宝正扫
//        bizParameter.addMapParam("payMode", ORDER_VSPPAY);//收银宝POS
//        bizParameter.addMapParam("payMode", CODEPAY_VSP);//付款码支付
//        bizParameter.addMapParam("payMode", H5_CASHIER_VSP);//H5收银台

        bizParameter.addParam("reqsUrl", "http://www.baidu.com");//前台通知地址
        bizParameter.addParam("respUrl", "http://test.allinpay.com/open/testNotify");//后台通知地址
        bizParameter.addParam("orderValidTime", orderValidTime);//订单过期时间
//        bizParameter.addParam("goodsType", "goodsType");//商品类型
//        bizParameter.addParam("bizGoodsNo", "bizGoodsNo123456");//商户商品编号
        bizParameter.addParam("goodsName", "goodsName123456");//商品名称
        bizParameter.addParam("goodsDesc", "goodsDesc123456");//商品描述
        bizParameter.addParam("summary", "摘要");
        bizParameter.addParam("extendParams", "{\"extend\":\"abcdefghiii\"}");

        // 发送请求
        TxClient txClient = new TxClient(demoConfig);
        TxResponse txResponse = txClient.sendRequest("2085", bizParameter);
        // 打印响应结果
        logger.info(txResponse.getBizData());

    }
}
