/**
 * create this file at 下午2:10:09 by renhd.
 */
package com.allinpay.yst2.demo.tx;

import com.alibaba.fastjson.JSON;
import com.allinpay.yst2.demo.util.DemoSM2Utils;
import com.allinpay.yst2.demo.util.DemoSM4Utils;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.util.StringUtils;
import org.springframework.web.client.RestTemplate;

import java.text.SimpleDateFormat;
import java.util.*;

import static com.allinpay.yst2.demo.tx.TxDemo.demoConfig;

/**
 * @description 个人进件
 * @author 任海东
 * @since 2024年6月17日
 */
//@SpringBootTest
class hy1070进件 {
	
	
	
      public static void main(String[] args) throws Exception{
    	  
    	  test(); 
      }

	@Test
	static
	void test() throws Exception {
		final ApiReq req = new ApiReq();
		req.setAppId(demoConfig.getAppId());
		req.setSpAppId(demoConfig.getSpAppId());
		req.setTransCode("1070");
		final Date date = new Date();
		req.setTransDate(new SimpleDateFormat("yyyyMMdd").format(date));
		req.setTransTime(new SimpleDateFormat("HHmmss").format(date));
		req.setCharset("UTF-8");
		req.setFormat("json");
		req.setVersion("1.0");
		req.setBizData(mockBizContent());
		req.setSignType("SM3withSM2");
		req.setSign(sign(req));
		System.out.println(req);
		final String resp = post(req);
		System.out.println(resp);
		Assertions.assertNotNull(resp);
	}

	/**
	 * @param req
	 */
	private static String post(final ApiReq req) {
		final HttpHeaders headers = new HttpHeaders();
		headers.setContentType(MediaType.APPLICATION_JSON);
		final HttpEntity<ApiReq> entity = new HttpEntity<>(req, headers);
		return new RestTemplate().postForObject("https://test.allinpay.com/solution/precusapi/api", entity, String.class);
	}
//生产环境地址：https://ics.allinpay.com/ystcusapi/api
	/**
	 * @param req
	 * @return
	 */
	private static String sign(final ApiReq req) throws Exception {
		final Map<String, String> copy = new TreeMap<>();
		JSON.parseObject(JSON.toJSONString(req)).forEach((k, v) -> {
			if (StringUtils.hasText((String) v)) {
				copy.put(k, (String) v);
			}
		});
		copy.remove("sign");
		copy.remove("signType");
		final StringBuilder sb = new StringBuilder();
		copy.forEach((k, v) -> sb.append(k).append("=").append(v).append("&"));
		final String src = sb.substring(0, sb.length() - 1);
		return DemoSM2Utils.sign(DemoSM2Utils.privKeySM2FromBase64Str(demoConfig.getPrivateKeyStr()), src);
	}

	/**
	 * @return
	 */
	private static String mockBizContent() throws Exception {


		final Map<String, Object> basic = new HashMap<>();
//会员基本信息
		basic.put("cusName", "云商通测试商户");
		basic.put("cusSimName", "测试使用");
//		basic.put("cusEnName", "");
//		basic.put("cusEnSimName", "");
		basic.put("comProperty", "3");//个人(1.企业 3.个体户 4.个人 6.事业单位)
		basic.put("servicePhone", "17621605022");//客服电话
		basic.put("mcc", "5311");
		basic.put("corpBusName", "竹溪县子怡鞋店");
		basic.put("creditCode", "92420324MA4D68J28J");
		basic.put("creditCodeExpire", "2056-12-31");
		basic.put("legalName", "王三华");
		basic.put("legalIdType", "01");
		basic.put("legalIdNo", DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(),"51370119380325580x"));
		basic.put("legalIdStartdate", "2020-10-24");
		basic.put("legalIdExpire", "2040-10-24");
		basic.put("address", "浦东新区金沪路55号");
		basic.put("contactPerson", "吴大名");//商户负责人
		basic.put("contactPhone", "18888889999");
		basic.put("registerFund", "5");
		basic.put("staffTotal", "5");
		basic.put("operateLimit", "1");
		basic.put("inspect", "1");
		basic.put("busConactPerson", "吴大明");//业务联系人
		basic.put("busConactTel", "18888888888");
//		basic.put("offlag", "");
//		basic.put("cusUrl", "");
//		basic.put("webName", "");
		basic.put("busDetail", "餐饮零售烟草专卖");
		basic.put("businessPlace", "1");
		basic.put("busAddress", "金沪路55号");
		basic.put("districtCode", "110101");
		basic.put("icpInfo", "");
		basic.put("appScenario", "");
		basic.put("personTel", "18818181818");
		basic.put("expandUser", "陈辉1(18897099799)");
		basic.put("clearTimeRule", "");

//受益人信息
		final Map<String, Object> bnf = new HashMap<>();
		bnf.put("legalCountry", "中国");
		bnf.put("legalSex", "1");
		bnf.put("legalCareer", "2");
		bnf.put("legalAddress", "金沪路55号");
		bnf.put("merchantType", "1");
		bnf.put("beneficiaryJudgmentCriteria", "1");
//		bnf.put("beneficiaryJudgmentFile", "");
		bnf.put("beneficiaryCerType", "01");
		bnf.put("beneficiaryName", "吴二氏");
		bnf.put("beneficiaryCerNum", DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(),"429005197502113030"));
		bnf.put("beneficiaryCerValidate", "2059-05-12");
		bnf.put("isSeniorManagement", "1");
		bnf.put("beneficiaryAddress", "乡村大院");
		bnf.put("shareholderName", "吴名氏");
		bnf.put("shareholderCerNum", DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(),"429005197502113033"));
		bnf.put("shareholderCerValidate", "2069-05-12");


//银行账户信息json
		final Map<String, Object> bank = new HashMap<>();
		bank.put("acctAttr", "1");
		bank.put("acctNum",  DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(),"6210830206"));
//		bank.put("bankReservePhone", "18229856545");
		bank.put("openBankNo", "01030000");
		bank.put("openBankBranchName", "中国农业银行股份有限公司北京樱桃园支行");
		bank.put("payBankNumber", "403100004030");
		bank.put("openBankProvince", "安徽省");
		bank.put("openBankCity", "合肥市");

//产品信息josn
		final List<Map<String, Object>> prodList = new ArrayList<>();
		final Map<String, Object> prod1 = new HashMap<>();
		prod1.put("pid", "P0003");
		prod1.put("mtrxCode", "VSP501");
		prod1.put("feeRate", "3.00");
//		prod1.put("creditRate", "5");
//		prod.put("feePen", "");
//		prod.put("feeCycle", "");
//		prod.put("lowLimit", "");
//		prod.put("topLimit", "");
		prodList.add(prod1);

		final Map<String, Object> prod2 = new HashMap<>();
		prod2.put("pid", "P0003");
		prod2.put("mtrxCode", "VSP511");
		prod2.put("feeRate", "5");
//		prod2.put("creditRate", "5");
//		prod.put("feePen", "");
		prod2.put("feeCycle", "2");
		prod2.put("lowLimit", "0.01");
//		prod.put("topLimit", "");
		prodList.add(prod2);


//门店信息json
		final List<Map<String, Object>> branchList = new ArrayList<>();
		final Map<String, Object> branch = new HashMap<>();
		branch.put("branchNo", "");
		branch.put("branchName", "门店1");
		branch.put("branchAddr", "金沪路55号");
		branch.put("contactPerson", "小冬瓜");
		branch.put("contactPhone", "18818181818");
		branch.put("districtCode", "110101");
		branchList.add(branch);

//附件材料
		final Map<String, Object> pic = new HashMap<>();
		pic.put("unifiedSocialCreditPhoto", "3320240711161811317747167244289");//3320240711161811315270413955073
		pic.put("legalFacePhoto","3320240711161811317747167244289");
		pic.put("legalNationalEmblemPhoto","3320240711161811317747167244289");
		pic.put("settleAcctPhoto", "3320240711161811317747167244289");
//		pic.put("legalPic","3320240402161775080930147479554");
		pic.put("businessDoorHeadPhoto","3320240711161811317747167244289");
		pic.put("businessInteriorPhoto","3320240711161811317747167244289");
//		pic.put("bizPlacePic", "3320240402161775080930147479554");
//		pic.put("otherFile", "");
		pic.put("personHeadPic", "3320240711161811317747167244289");
//		pic.put("beneficiaryFile", "");

		final Map<String, Object> params = new HashMap<>();
		params.put("reqTraceNum", new SimpleDateFormat("MMddHHmmss").format(new Date()) + System.currentTimeMillis());
		params.put("signNum", "711002345678891");
		params.put("notifyUrl", "http://test.allinpay.com/open/testNotify");//http://test.allinpay.com/open/testNotify
		params.put("merAddBasicInfo", basic);
		params.put("merAddBeneficiaryInfo", bnf);
		params.put("merAddBankAcctInfo", bank);
		params.put("merAddProductInfo", prodList);
		params.put("merAddBranchInfo", branchList);
		params.put("merAddAttachmentInfo", pic);

		return JSON.toJSONString(params);
	}

}
