/**
 * create this file at 下午2:10:09 by renhd.
 */
package com.allinpay.yst2.demo.tx;

import com.alibaba.fastjson.JSON;
import com.allinpay.yst2.demo.util.DemoSM2Utils;
import com.allinpay.yst2.demo.util.DemoSM4Utils;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.util.StringUtils;
import org.springframework.web.client.RestTemplate;

import java.text.SimpleDateFormat;
import java.util.*;

import static com.allinpay.yst2.demo.tx.TxDemo.demoConfig;

/**
 * @description 个人进件
 * @author 任海东
 * @since 2024年6月17日
 */
//@SpringBootTest
class hy1076合规补录 {

	@Test
	void test() throws Exception {
		final ApiReq req = new ApiReq();
		req.setAppId(demoConfig.getAppId());
		req.setSpAppId(demoConfig.getSpAppId());
		req.setTransCode("1076");
		final Date date = new Date();
		req.setTransDate(new SimpleDateFormat("yyyyMMdd").format(date));
		req.setTransTime(new SimpleDateFormat("HHmmss").format(date));
		req.setCharset("UTF-8");
		req.setFormat("json");
		req.setVersion("1.0");
		req.setBizData(mockBizContent());
		req.setSignType("SM3withSM2");
		req.setSign(sign(req));
		System.out.println(req);
		final String resp = post(req);
		System.out.println(resp);
		Assertions.assertNotNull(resp);
	}

	/**
	 * @param req
	 */
	private String post(final ApiReq req) {
		final HttpHeaders headers = new HttpHeaders();
		headers.setContentType(MediaType.APPLICATION_JSON);
		final HttpEntity<ApiReq> entity = new HttpEntity<>(req, headers);
		return new RestTemplate().postForObject("http://192.168.14.132:8888/api", entity, String.class);
	}
//生产环境地址：https://ics.allinpay.com/ystcusapi/api
	/**
	 * @param req
	 * @return
	 */
	private String sign(final ApiReq req) throws Exception {
		final Map<String, String> copy = new TreeMap<>();
		JSON.parseObject(JSON.toJSONString(req)).forEach((k, v) -> {
			if (StringUtils.hasText((String) v)) {
				copy.put(k, (String) v);
			}
		});
		copy.remove("sign");
		copy.remove("signType");
		final StringBuilder sb = new StringBuilder();
		copy.forEach((k, v) -> sb.append(k).append("=").append(v).append("&"));
		final String src = sb.substring(0, sb.length() - 1);
		return DemoSM2Utils.sign(DemoSM2Utils.privKeySM2FromBase64Str(demoConfig.getPrivateKeyStr()), src);
	}

	/**
	 * @return
	 */
	private String mockBizContent() throws Exception {



	//	pic.put("unifiedSocialCreditPhoto", "3320240711091811208321643032577");


		final Map<String, Object> params = new HashMap<>();
		params.put("reqTraceNum", new SimpleDateFormat("MMddHHmmss").format(new Date()) + System.currentTimeMillis());
		params.put("signNum", "9911900504565AB123");
		params.put("notifyUrl", "http://test.allinpay.com/open/testNotify");
		params.put("cusShortName", "新的简称");
		params.put("storePic", "3320240711091811216332855947266");
		params.put("innerPic", "3320240711091811216332855947266");

		return JSON.toJSONString(params);
	}

}
